/*++

Module Name:

    test.c

Abstract:

    Skeletal test program for CSE451 Project #1 "NT API Monitoring"

    This test program calls NtQuerySystemInformation specifing the CSE451
    information class which has been dummied up to do a compare exchange
    operation.  This test program takes two numbers from the command-line.
    The first number is ExChange value and the second is the Comprehand.

    It is left as an exercise to figure out the semantics of this test
    program.

--*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <nt.h>
#include <ntrtl.h>
#include <nturtl.h>

VOID
__cdecl
main (argc, argv)
    int argc;
    char *argv[];
{
    NTSTATUS Status;

    SYSTEM_CSE451_SYSCALL_INFORMATION Cse451SyscallInfo;
    ULONG Size;


    //
    //  Do the system call and print succes or failure
    //

    if (!NT_SUCCESS(Status = NtQuerySystemInformation( SystemCSE451SyscallInformation,
                                                       &Cse451SyscallInfo,
                                                       sizeof(SYSTEM_CSE451_SYSCALL_INFORMATION),
                                                       &Size))) {

        printf("<<<Error>>>");

    } else {

		printf("Syscall Summary----------------------------------------\n");
		
		printf("NtCreateFile:\n");
		printf("\tSuccess: %u\n", Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Success);
		printf("\tInformation: %u\n", Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Information);
		printf("\tWarning: %u\n", Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Warning);
		printf("\tError: %u\n", Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Error);
		printf("\tTotal: %u\n", 
			Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Success + 
			Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Information +
			Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Warning +
			Cse451SyscallInfo.Statistics[CSE451_CREATE_IDX].Error
			);

		printf("\n");

		printf("NtOpenFile:\n");
		printf("\tSuccess: %u\n", Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Success);
		printf("\tInformation: %u\n", Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Information);
		printf("\tWarning: %u\n", Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Warning);
		printf("\tError: %u\n", Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Error);
		printf("\tTotal: %u\n", 
			Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Success + 
			Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Information +
			Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Warning +
			Cse451SyscallInfo.Statistics[CSE451_OPEN_IDX].Error
			);

		printf("\n");

		printf("NtReadFile (Total Bytes Read - %u):\n", Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Bytes);
		printf("\tSuccess: %u\n", Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Success);
		printf("\tInformation: %u\n", Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Information);
		printf("\tWarning: %u\n", Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Warning);
		printf("\tError: %u\n", Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Error);
		printf("\tTotal: %u\n", 
			Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Success + 
			Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Information +
			Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Warning +
			Cse451SyscallInfo.Statistics[CSE451_READ_IDX].Error
			);

		printf("\n");

		printf("NtWriteFile (Total Bytes Written - %u):\n", Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Bytes);
		printf("\tSuccess: %u\n", Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Success);
		printf("\tInformation: %u\n", Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Information);
		printf("\tWarning: %u\n", Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Warning);
		printf("\tError: %u\n", Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Error);
		printf("\tTotal: %u\n", 
			Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Success + 
			Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Information +
			Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Warning +
			Cse451SyscallInfo.Statistics[CSE451_WRITE_IDX].Error
			);
		printf("-------------------------------------------------------\n");
    }
}
